/*jshint esversion: 6 */

var r = document.querySelector(":root");
var tagHTML = document.getElementsByTagName('HTML')[0];
var tagBody = document.getElementsByTagName('BODY')[0];
var idKeyCont = document.getElementsByClassName("keycontainer")[0];
var tagMain = document.getElementsByTagName('MAIN')[0];
var idMainPart = document.getElementById("main-part");
var idMainPartInt = document.getElementById("main-part-interior");
var idRightNav = document.getElementById('right-nav');
var idGoLeft = document.getElementById('goleft');
var idGoRight = document.getElementById('goright');
var idGoTop = document.getElementById('gotop');

var idLoader = document.getElementById('loader');
var sessionStarted = sessionStorage.getItem('sessionStarted');

var bckgrndFlag = localStorage.getItem('bckgrndFlag');
var bkgdClr = localStorage.getItem('bkgdClr');
var bkgdPrv = localStorage.getItem('bkgdPrv');
var darkFlag = localStorage.getItem('darkFlag');
var idcbBckgrnd = document.getElementById('cbNight');
var idBckgrnd = document.getElementById('optBkgdClr');

var idCbHead = document.getElementById("cbHead");
var HeadingsFlag = localStorage.getItem("HeadingsFlag");
var leftNav = document.getElementById("left-nav");
var lnavLogo = document.getElementById("TBU-logo");
var lnavEdtn = document.getElementById("left-nav-edition");

var idMenuOverlays = document.getElementById("menuOverlays");
var idSmlMenu = document.getElementById("sml-menu");
var idSmlBuff = document.getElementById("sml-menu-buffer");

var idCbComm = document.getElementById("cbComm");
var idCbHlt = document.getElementById('cbHlt');
var idCbFont = document.getElementById("cbFont");
var idCbTogBtns = document.getElementById('cbTogBtns');

var CommentsFlag = localStorage.getItem('CommentsFlag');
var VerseFontFlag = localStorage.getItem('VerseFontFlag');
var toggleBtnsFlag = localStorage.getItem('toggleBtnsFlag');
var frmElementsReset;

var idBkmkPane = document.getElementById('bkmkPane');
var idBkmkExtra = document.getElementById('bkmkExtras');
var idBkmkName = document.getElementById('bkmkName');
var bkmkExtra;
var bkmkLabelNum;
var bkmksSetUp;
var bkmksOpen;
var idBkmk1 = document.getElementById('bkmk1');
var idBkmk2 = document.getElementById('bkmk2');
var idBkmk3 = document.getElementById('bkmk3');
var idBkmk4 = document.getElementById('bkmk4');
var idBkmk5 = document.getElementById('bkmk5');
var idBkmk6 = document.getElementById('bkmk6');
var idBkmk7 = document.getElementById('bkmk7');
var idBkmk8 = document.getElementById('bkmk8');
var idGoTo1 = document.getElementById('goTo1');
var idGoTo2 = document.getElementById('goTo2');
var idGoTo3 = document.getElementById('goTo3');
var idGoTo4 = document.getElementById('goTo4');
var idGoTo5 = document.getElementById('goTo5');
var idGoTo6 = document.getElementById('goTo6');
var idGoTo7 = document.getElementById('goTo7');
var idGoTo8 = document.getElementById('goTo8');

var sldr = document.getElementById("rnRange");

var idOptOpenDsk = document.getElementById("optOpenDsk");
var idOptions = document.getElementById("options");
var idLineHt = document.getElementById("optLineHt");
var lnHgt = localStorage.getItem('lnHgt');
var idFontSize = document.getElementById("optFontSize");
var fSize = localStorage.getItem('fSize');
var pal = document.getElementById("palette");

var dskMenuFlag = localStorage.getItem('menuFlag');
var paneLtFlag = localStorage.getItem('paneLtFlag');

var formatOnOff = localStorage.getItem('formatOnOff');
var formatCounter = parseInt(localStorage.getItem('formatCounter'));

var onLoadRan;
var edition;
var rnWidth;
var goArrowStart;
var unit;
var bkmkUnit;
var scrollToBkmk;
var goTopFlag;
var displayNavBtns;
var colOptOpen;
var tipsOpen;
var isIOS = iOSCheck();
var isAndrd;
var isMac;
var isTchScrn = sessionStorage.getItem('isTchScrn');
var i;

var optExpBox;
var openingLrgMenu;
var closingLrgMenu;
var openMenuName;
var smallMenuOpen;
var smallOverlayOpen;


var sldrBkgdTop = document.getElementById("bkgdSldrTop");
var sldrBkgdApp = document.getElementById("sml-bkgdSldrTop");
var sldrBkgd = document.getElementById("bkgdSldr");
const sldrBkgdClass = document.getElementsByClassName('bkgdRange');
var ltYlwLgt;
var ltYlwSldr;
var ltBlueLgt;
var ltBlueSldr;
var dkBlackLgt;
var dkBlackSldr;
var dkBlueLgt;
var dkBlueSldr;

var dkUnitLgt;
var dkUnitSldr;
var dkUnitSldrName;
var dkUnitPrev;
var dkUnitHuePrev;
var ltUnitLgt;
var ltUnitSldr;
var ltUnitSldrName;
var ltUnitPrev;
var ltUnitHuePrev;

var hue;
var stn;
var lgt;
var lgtStart;
var bkgrClr;



// for pageNav modal; not on all pages
try {
    var idPgNvModal = document.getElementById("pgNvModal");
    var idPgNvOk = document.getElementById("ok-btn");
    var pgNvMdlOnce = sessionStorage.getItem('pgNvMdlOnce');
    var pgNvMdlNever = localStorage.getItem('pgNvMdlNever');
}
catch (err) {
}



function iOSCheck() {
    let isIOS1 = (/iPad|iPhone|iPod/.test(navigator.userAgent)) || (navigator.platform === 'MacIntel' && navigator.maxTouchPoints > 1) && !window.MSStream;
    let isIOS2 = iOSCheck2();
    if (isIOS1 || isIOS2) { return true; }
}

function iOSCheck2() {
    return [
        'iPad Simulator',
        'iPhone Simulator',
        'iPod Simulator',
        'iPad',
        'iPhone',
        'iPod'
    ].includes(navigator.platform) || (navigator.userAgent.includes("Mac") && "ontouchend" in document); // latter bit for iPad on iOS 13 detection
}

//idGoBack.addEventListener('click', event => { event.stopPropagation(); });


function mediaCheck(x) {
    if (x.matches) { // If media query matches, i.e. width >= 961px
        // error trap needed for editions without lrg menus
        try {
            const cssObj = window.getComputedStyle(idMenuOverlays, null);
            idSmlMenu.style.top = '-100vh';
            if (sessionStorage.getItem('toPortrait') =='y') {
                 // In case large menu opened in landscape & closed when was in portrait
                if (cssObj.getPropertyValue("right") == "0px") {
                    closeLrgOverlay();
                }
                localStorage.setItem('toPortrait', 'n');
            }
        }
        catch (err) {
        }
    } else {
        sessionStorage.setItem('toPortrait', 'y');
    }
}

var x = window.matchMedia("(min-width: 961px)");
mediaCheck(x); // Call listener function at run time
x.addListener(mediaCheck); // Attach listener function on state changes
var x549 = window.matchMedia("(max-width: 549px)");

// check if is touch screen device
if (('ontouchstart' in window) || (navigator.maxTouchPoints > 0) || (navigator.msMaxTouchPoints > 0)) {
    isTchScrn = 'y';
    sessionStorage.setItem('isTchScrn', 'y');
    tagBody.classList.add("tchScrn");
}

// This is called when a page is loaded
function invert(caller, pageUnit, editionName, cbFlag) {
    if (caller == 'body0') { tagBody.classList.add("preload"); }
   // alert(pageUnit);

    if (pageUnit != null) {unit = pageUnit;}
    if (editionName != null) { edition = editionName;}

    // check if session started before this page load - so cover page js knows if diverts to last page of last session
    if (sessionStarted != 'y') {
        sessionStorage.setItem('sessionStarted', 'y');
        sessionStarted = 'y';
    }

    if (editionName == 'twomin') {
        // ltUnit & dkUnit not available in twominute
        //if (bkgdClr == 'ltUnit' || bkgdClr == 'dkUnit') {
        //    //bkgdClr == 'dkBlue';
        //    //idBckgrnd.value = 'dkBlue';
        //    bckgrndFlag = "off"; 
        //}
        if (bkgdClr == 'ltUnit' || bkgdClr == 'dkUnit') { bckgrndFlag = "off"; }
    }
    // check for background color. Default to dkBlue if is null or an old one.
    switch (bkgdClr) {
        case null:
        case 'ltRed':
        case 'ltGrn':
        case 'dkRed':
        case 'dkPlum':
            bkgdClr = 'dkBlue'; localStorage.setItem('bkgdClr', bkgdClr); darkFlag = 'on'; localStorage.setItem('darkFlag', 'on');
            if (isNaN(formatCounter) || formatCounter == null) {formatCounter = 1;}
            break;
        default:
            idBckgrnd.value = bkgdClr;
    }

    if (bckgrndFlag == "on" && caller == 'body0') {
        tagBody.classList.add("bkgd");
        bckgrndChange('body0');
        idcbBckgrnd.checked = true;

    } else if (bckgrndFlag != "on" && caller == 'btn') {
        tagBody.classList.add("bkgd");
        tagBody.classList.add(bkgdClr);
        bckgrndFlag = "on";
        bckgrndChange('btnOn');
        if (cbFlag != 'chbox') {
            idcbBckgrnd.checked = true;
        }
        localStorage.setItem("bckgrndFlag", "on");

    } else if (bckgrndFlag == "on" && caller == 'btn') {
        tagBody.classList.remove("bkgd");
        tagBody.classList.remove(bkgdClr);
        tagBody.style.backgroundColor = null;
        if (darkFlag == "on") { tagBody.classList.remove("night"); defaultClrs(); }
        if (cbFlag != 'chbox') {
            idcbBckgrnd.checked = false;
        }
        bckgrndFlag = "off";
        localStorage.setItem("bckgrndFlag", "off");
    }

    if (caller == "btn") {
        if (formatOnOff == 'on' && edition != "twomin" && edition != 'pkt') {
            highlightApply();
        }
    } else if (caller == 'body0') {
        // ensure menus closed. Needed if using back arrow to page that had menu open.
        if (tagHTML.className !== '' && tagHTML.className !== 'btnsVis') {
            if (x.matches) {
                const myClassList = tagHTML.classList;
                const lastClass = myClassList[myClassList.length - 1];
                closeLrgOverlay(lastClass, 'body0');
            } else {
                closeSmlMenu();
            }
        }
        toggleComments('body0');
        fontToggle('body0');
        fontSize('body0');
        lineHt('body0');
        toggleBtns('body0');
        dskMenuToggle('body0');
        paneMove('body0');

        sessionStorage.setItem("unitName", unit);  // is this line needed? unitName not anywhere else

        if (edition != 'twomin' && edition != 'pkt') {
            highlightChoice(formatCounter, 'body0');
            highlightToggle('body0');
        } else {
            HeadingsFlag = "off";
        }
        // Set "lastPageWithHeadings" to blank in case headings panel is put on again & the page hasn't been changed (so that don't get listeners added again.)
        sessionStorage.setItem("lastPageWithHeadings", "");
        openMenuName = '';
    }

    if (HeadingsFlag == "on" && caller == 'body0') {
        document.getElementById("cbHead").checked = true;
        toggleHeadings('body0');
    }
    window.addEventListener('scroll', bodyScroll);

    // check if iOS, or other Safari or Android
    if (isIOS) {
        tagBody.classList.add('iOS');
    // check if other Safari or Android
    } else {
        var ua = navigator.userAgent.toLowerCase();
        if (ua.indexOf('android') > -1) {
            tagBody.classList.add('android');
            isAndrd = true;
        } else if (ua.indexOf('mac') > -1) {
            tagBody.classList.add('mac');
            isMac = true;
        }
    }

    onLoadRan = 'y';
    onloadMisc();

    setTimeout(function () { tagBody.classList.remove('preload'); }, 5);
    setTimeout(function () { tagBody.style.visibility = 'initial'; }, 15);
    
    // Store this page in variable for last page visited, unless is cover page
    setTimeout(function () { localStorage.setItem('lastPage-'.concat(edition), window.location.href); }, 10);

}

function onloadMisc() {
    // things in here don't need to be loaded immediately

    //bkmk on load
    if (sessionStorage.getItem('bkmkActivated') == 'Y') {
        let bkNum = sessionStorage.getItem('bkmkNumActivated');
        bkmkFromTop(bkNum);
        sessionStorage.setItem('bkmkActivated', 'N');
    }

    //pgNav on load
    if (idPgNvModal != null) {
        if (pgNvMdlOnce != 'y' && pgNvMdlNever != 'y') {
            setTimeout(function () { idPgNvModal.style.display = "block"; idPgNvOk.focus(); }, 1500);
            pgNvMdlOnce = 'y';
            sessionStorage.setItem('pgNvMdlOnce', 'y');
        }
    } 

    if (x549.matches) {
        // Show goTop if not at top
        if (tagBody.scrollTop > 2 || tagHTML.scrollTop > 2) {
            idKeyCont.classList.add('goTop');
         // Shorten ind-lnks if at top
       } else if (tagBody.scrollTop < 2 && tagHTML.scrollTop < 2) {
            idKeyCont.classList.add('indxAtTop');
        }
    }

    // re if Color part is open in settings pane
    colOptOpen = sessionStorage.getItem('colOptOpen');
    if (colOptOpen == 'Y') {
        idOptions.classList.add("optsColorOpen");
    }
}

window.addEventListener('pageshow', function () {
    // if onload not activated due to caching, call invert function
    if (onLoadRan != 'y') { invert('body0'); }
});

// close any open menu on orientationchange
window.addEventListener('orientationchange', openMenuCheck);
function openMenuCheck() {
    if (tagHTML.className !== "" && tagHTML.className !== "btnsVis") {
        idMenuOverlays.style.transition = 'none';
        tagBody.classList.add("preload");
        closeSmlOverlay();
        setTimeout(function () { idMenuOverlays.style.transition = null; tagBody.classList.remove("preload"); }, 10);
    }
}

var prevScrollpos = window.pageYOffset;
function bodyScroll(caller) {
    if (!x549.matches) {
        // When scroll down >20px from the top of the document, show gotop button
        displayGoTop();
    } else if (displayNavBtns != false) {
        // But on small screens: when scroll down - hide top, left & right buttons; when scroll up (or if at bottom of page) - show top, left & right buttons
        let currentScrollPos = window.pageYOffset;
        if ((window.innerHeight + window.scrollY) >= idKeyCont.offsetHeight - 100) {
            // near bottom
            idKeyCont.classList.remove('noLftRt');
            idKeyCont.classList.add('goTop');
        } else if (prevScrollpos > currentScrollPos + 2) {
            // scrolling up
            idKeyCont.classList.remove('noLftRt');
            if (tagBody.scrollTop < 2 && tagHTML.scrollTop < 2) {
                // at top
                idKeyCont.classList.remove('goTop');
                idKeyCont.classList.add('indxAtTop');
            } else {
                idKeyCont.classList.add('goTop');
                idKeyCont.classList.remove('indxAtTop');
            }
        } else if ((prevScrollpos < currentScrollPos - 4) || caller =='indxScrl') {
            // scrolling down
            idKeyCont.classList.add('noLftRt');
            idKeyCont.classList.remove('goTop');
        }
        prevScrollpos = currentScrollPos;
    }
}

function toggleHeadings(caller, cbFlag) {
    let idCbHead = document.getElementById("cbHead");

    if (sessionStorage.getItem('rPaneInTrans') == 'Y') {
        //needed next line as can get stuck at rPaneInTrans == Y
        setTimeout(function () { sessionStorage.setItem('rPaneInTrans', 'N'); }, 1000);      
        if (cbFlag == 'chbox') {   // change switch back after what would be a quick 2nd click
            idCbHead.checked = !idCbHead.checked;
        }
        return;
    }

    // displays headings on RHS
    if ((HeadingsFlag != "on" && caller == 'btn') || (HeadingsFlag == "on" && caller == 'body0' && x.matches != false)) {

        if (caller == "body0") {
            tagBody.classList.add("rightPane");
        }  // if caller is body0, add rightPane immediately.

        // get rnWidth
        rnWidth = localStorage.getItem('rtnavWidth');
        if (rnWidth == null) {
            setSldrMaxMin();
            sldr.value = (parseInt(sldr.max) + parseInt(sldr.min)) / 2;
            rnWidth = sldr.value;
            localStorage.setItem('rtnavWidth', rnWidth);
        } else {
            //  Reset slider: max, min, value
            sldr.min = localStorage.getItem('SliderMin');
            sldr.max = localStorage.getItem('SliderMax');
            sldr.value = rnWidth;
        }
        goArrowStart = (parseInt(rnWidth) + 2) + 'px';

        // open right nav
        if (caller == "btn") {
            transitionRNav_Main('open');
            if (cbFlag != 'chbox') {
                idCbHead.checked = true;
            }
        } else {
            r.style.setProperty('--rnwidth', rnWidth + 'px');
            r.style.setProperty('--rnCtrlsWidth', rnWidth - 3 + 'px');
        }

        // hide headings on RHS
    } else if (HeadingsFlag == "on" && caller == 'btn') {
        setTimeout(transitionRNav_Main, 10, 'close');
        setTimeout(settingsAfterCloseHeadings, 1020);
        if (cbFlag != 'chbox') {
            idCbHead.checked = false;
        }
        if (optExpBox == 'RNvArws') {
            document.getElementById("expRNvArws").style.display = null;
            optExpBox = null;
        }
    }

    if (caller == "btn") {
        if (HeadingsFlag != "on") {
            HeadingsFlag = "on";
            localStorage.setItem("HeadingsFlag", HeadingsFlag);
        }
    }
}


function transitionRNav_Main(openClose) {

    // set flag to ensure transition finishes before further call
    sessionStorage.setItem('rPaneInTrans', 'Y');
    setTimeout(function () { sessionStorage.setItem('rPaneInTrans', 'N'); }, 1500);

    if (openClose == 'open') {
        r.style.setProperty('--rnwidth', rnWidth + 'px');
        r.style.setProperty('--rnCtrlsWidth', rnWidth - 3 + 'px');
        //tagBody.classList.add("rightPane");

        // set starting values
        if (paneLtFlag != 'on') {   // pane opens from RHS
            idRightNav.style.left = '100%';
        } else if (dskMenuFlag != 'on') {
            idRightNav.style.left = (0 - rnWidth) + 'px';
        } else {
            idRightNav.style.left = (206 - rnWidth) + 'px';
        }
        // transitionRNav_DelaysOpen();
        setTimeout(transitionRNav_DelaysOpen, 1);

    } else {
        // close headings pane
        setTimeout(transitionRNav_DelaysClose, 10);
    }

    setTimeout(function () {
        idRightNav.style.left = null;
        idOptions.style.right = null;
        idOptions.style.width = null;
        idOptions.style.marginLeft = null;
        idMainPart.style.marginLeft = null;
        idMainPart.style.marginRight = null;
        idGoLeft.style.marginLeft = null;
        idGoRight.style.marginRight = null;
        idGoTop.style.marginRight = null;
    }, 1020);
}

function transitionRNav_DelaysOpen() {
    if (paneLtFlag != 'on') {
        idRightNav.style.left = 'calc(100% - var(--rnwidth))';
    } else if (dskMenuFlag == 'on') {
        idRightNav.style.left = '206px';
    } else {
        idRightNav.style.left = '0%';
    }
    tagBody.classList.add("rightPane");
}

function transitionRNav_DelaysClose() {
    // When closing pane, values need to be set here to their closed values,
    // prior the "rightPane" class being removed (after pane has closed).
    if (paneLtFlag != 'on') {
        idRightNav.style.left = '100%';
        idMainPart.style.marginRight = '0';
        idOptions.style.right = '0';
        idGoRight.style.marginRight = '0';
        idGoTop.style.marginRight = '0';
    } else {
        idMainPart.style.marginLeft = '0';
        idOptions.style.marginLeft = '0%';
        if (dskMenuFlag == 'on') {
            idRightNav.style.left = (206 - rnWidth) + 'px';
            idGoLeft.style.marginLeft = '206px';
        } else {
            idRightNav.style.left = (0 - rnWidth) + 'px';
            idGoLeft.style.marginLeft = '0';
        }
    }
    if (dskMenuFlag == 'on') {
        idOptions.style.width = 'calc(100% - 206px)';
    } else {
        idOptions.style.width = '100%';
    }
}

function settingsAfterCloseHeadings() {
    // Called from function toggleHeadings
    tagBody.classList.remove("rightPane");
    HeadingsFlag = "off";
    localStorage.setItem("HeadingsFlag", HeadingsFlag);
}


// slider
sldr.oninput = function () {
    rnWidth = sldr.value;
    r.style.setProperty('--rnCtrlsWidth', rnWidth - 3 + 'px');
    r.style.setProperty('--rnwidth', rnWidth + 'px');
};

// 'touched' class sets relevant transitions back to 0s while slider is being used.
sldr.ontouchstart = function () {
    tagBody.classList.add('touched');
};
sldr.ontouchend = function () {
    tagBody.classList.remove('touched');
    localStorage.setItem('rtnavWidth', rnWidth);
    setSldrMaxMin();
};
sldr.onmousedown = function () {
    tagBody.classList.add('touched');
};
sldr.onmouseup = function () {
    tagBody.classList.remove('touched');
    localStorage.setItem('rtnavWidth', rnWidth);
    setSldrMaxMin();
};


function setSldrMaxMin() {
    let chwidth = tagMain.offsetWidth;
    if (chwidth > '1400') {
        sldr.max = '800';
        sldr.min = '350';
    } else if (chwidth > '1200') {
        sldr.max = '660';
        sldr.min = '300';
    } else if (chwidth > '1100') {
        sldr.max = '560';
        sldr.min = '280';
    } else if (chwidth > '1000') {
        sldr.max = '530';
        sldr.min = '250';
    } else if (chwidth > '870') {
        sldr.max = '440';
        sldr.min = '250';
    } else {
        sldr.max = '350';
        sldr.min = '250';
    }
    localStorage.setItem("SliderMax", sldr.max);
    localStorage.setItem("SliderMin", sldr.min);
}

function toggleComments(caller, cbFlag) {
    // On mobiles, prevent nav buttons showing if not already
    if (caller == 'btn' && x549.matches) { displayNavBtns = false; }

    if (CommentsFlag == 'on' && (caller == 'body0' || caller == 'bkmkFromTop')) {
        tagBody.classList.add("noTrans");
        tagBody.classList.add("com-on");
        idCbComm.checked = true;
        setTimeout(function () { tagBody.classList.remove("noTrans"); },10);
    } else if ((CommentsFlag != 'on' && caller == 'bkmkFromTop') || (CommentsFlag == 'on' && caller == 'btn')) {
        tagBody.classList.remove("com-on");
        CommentsFlag = 'off';
        if (cbFlag != 'chbox') {
            idCbComm.checked = false;
        }
        localStorage.setItem('CommentsFlag', 'off');
    } else if (CommentsFlag != 'on' && caller == 'btn') {
        CommentsFlag = 'on';
        localStorage.setItem('CommentsFlag', 'on');
        tagBody.classList.add("com-on");
        if (cbFlag != 'chbox') {
            idCbComm.checked = true;
        }
    }
    setTimeout(function () { displayNavBtns = null; }, 900);
}
function comOnLoopNull() {
    document.querySelectorAll('.tran').forEach(function (e) { e.style.transition = null; });
}


function openSmlMenu(caller) {
    if (caller == 'app') {
        if (smallOverlayOpen == 'y') {
            closeSmlOverlay();
            smallOverlayOpen = 'n';
            return;
        } else if (smallMenuOpen == 'y') {
            closeSmlMenu();
            smallMenuOpen = 'n';
            return;
        }
    }
    if (x.matches) {
        dskMenuToggle('btn');
    }
    setTimeout(function () { idSmlMenu.style.top = "0"; }, 10);
    setTimeout(function () { idSmlBuff.style.display = "block"; }, 900);
    smallMenuOpen = 'y';
    //if (toggleBtnsFlag == 'on') {
    //    tagHTML.className = "btnsVis";
    //} else {
    //    tagHTML.className = "";
    //}
    if (bkmksOpen == 'y') {
        closeBkmkBox();
    }
    if (idOptions.clientHeight > '0') {
        closeOpt();
    }
}

function closeSmlMenu() {
    idSmlBuff.style.display = null;
    idSmlMenu.style.top = null;
}


function openSmlOverlay(p1) {
    idMenuOverlays.style.transition = 'right 0.65s';
    tagHTML.classList.add(p1);
    // delay opening slightly
    setTimeout(function () { idMenuOverlays.style.right = "0"; }, 10);
    smallOverlayOpen = 'y';
    }

function openLrgOverlay(p1) {
    if (closingLrgMenu == 'y' || openingLrgMenu == 'y') {
        return;
    }
    const idCell = document.getElementById(p1);
    // If menu clicked is already open, close & exit.
    if (openMenuName == p1) {
        closeLrgOverlay(p1);
        return;
    }
    if (openMenuName != "") {
        tagHTML.classList.remove(openMenuName);
    } else {
        idCell.style.borderRight = 'solid white 3px';
    }
    openingLrgMenu = 'y';
    tagHTML.classList.add(p1);
    idMenuOverlays.style.transition = 'right 0.75s';
    // delay opening slightly
    setTimeout(function () { idMenuOverlays.style.right = "0"; }, 10);
    setTimeout(function () { idCell.style.borderRight = null; leftNav.style.borderRight = 'initial'; }, 750);
    openMenuName = p1;
    setTimeout(function () { openingLrgMenu = 'n'; }, 800);
    if (bkmksOpen == 'y') {
        closeBkmkBox();
    }
    if (idKeyCont.classList.contains('optOpen')) {
        closeOpt();
    }
}

function closeSmlOverlay() {
    idMenuOverlays.style.right = null;
    setTimeout(delayCloseSmlOverlay, 700);
}
function delayCloseSmlOverlay() {
    if (toggleBtnsFlag == 'on') {
        tagHTML.className = "btnsVis";
    } else {
        tagHTML.className = "";
    }
    idMenuOverlays.style.transition = null;
}

function closeLrgOverlay(q2, caller) {
    if ((openingLrgMenu == 'y' || closingLrgMenu == 'y') && dskMenuFlag != 'on') {
        return;
    }
    closingLrgMenu = 'y';
    // error trap needed if called from mediaCheck change or iLnk() or dskMenuToggle()
    try {
        const idCell = document.getElementById(q2);
        idCell.style.borderRight = 'solid white 3px';
        if (caller == 'body0') {
            idCell.style.borderRight = null;
        } else {
            setTimeout(function () { idCell.style.borderRight = null; }, 751);
        }
    }
    catch (err) {
    }
    openMenuName = '';
    if (caller == 'body0') {
        removeMenuClass();
        idMenuOverlays.style.transition = null;
        closingLrgMenu = 'n';
    } else {
        setTimeout(removeMenuClass, 750);
        setTimeout(function () { idMenuOverlays.style.transition = null; closingLrgMenu = 'n'; }, 800);
    }
    idMenuOverlays.style.right = null;
    leftNav.style.borderRight = null;
    lnavLogo.style.borderRight = null;
    lnavEdtn.style.borderRight = null;
}
function removeMenuClass() {
    if (toggleBtnsFlag == 'on') {
        tagHTML.className = "btnsVis";
    } else {
        tagHTML.className = "";
    }
}

function displayGoTop() {
    if (tagBody.scrollTop > 20 || tagHTML.scrollTop > 20) {
        idKeyCont.classList.add('goTop');
    } else {
        idKeyCont.classList.remove('goTop');
        if (goTopFlag) {  // if topFunction was activated
            // ensure nothing stays selected
            let sel = document.getSelection();
            sel.removeAllRanges();
            goTopFlag = false;
        }
    }
}


// When the user clicks on the button, scroll to the top of the document
function topFunction() {
    tagBody.scrollTop = 0; // for older iOS
    tagHTML.scrollTop = 0;
    goTopFlag = true;
}


function highlightToggle(caller) {
    if ((formatOnOff != 'on' && caller != 'body0') || (formatOnOff == 'on' && caller == 'body0')) {
        formatOnOff = 'on';
        tagBody.classList.remove('hltOff');
        localStorage.setItem('formatOnOff', 'on');
        if (caller != 'chbx') {
            idCbHlt.checked = true;
        }
        highlightApply();
    } else if ((formatOnOff == 'on' && caller != 'body0') || (formatOnOff != 'on' && caller == 'body0')) {
        // remove current class & add 'txtNormal'
        tagMain.className = '';
        tagMain.classList.add('txtNormal');

        formatOnOff = 'off';
        tagBody.classList.add('hltOff');
        localStorage.setItem('formatOnOff', 'off');
        if (caller != 'chbx') {
            idCbHlt.checked = false;
        }
    }
}

function highlightChoice(selectedNum, caller) {
    formatCounter = selectedNum;
    // return if semi-bold is unavailable
    if (formatCounter == 6 && !tagBody.classList.contains('SanSerif')) {
        return;
    }

    const y1 = pal.children[0].getElementsByTagName("P");
    const y2 = pal.children[1].getElementsByTagName("P");

    // if caller is body0, formatCounter might not be yet defined
    if (isNaN(formatCounter) || formatCounter == null) {
        formatCounter = 7;
    }
    // ensure all format options don't have a grey border to indicate selected. ie reset them all.
    // plus other options to reset
    for (i = 0; i < y1.length; i++) {
        y1[i].style.border = null;
        y1[i].style.paddingTop = null;
        y2[i].style.border = null;
        y2[i].style.paddingTop = null;
    }

    // set border of selection to a grey color
    if (formatCounter < 5) {
        y1[formatCounter - 1].style.border = 'ridge 4px rgb(204 204 204)';
        y1[formatCounter - 1].style.paddingTop = '1px';
    } else {
        y2[formatCounter - 5].style.border = 'ridge 4px rgb(204 204 204)';
        y2[formatCounter - 5].style.paddingTop = '1px';
    }

    localStorage.setItem('formatCounter', String(formatCounter));
    if (formatOnOff == 'on' && caller != 'body0') {
        highlightApply();
    }
}


function highlightApply() {
    if (formatCounter == null) {
        formatCounter = 4;
    }

    // remove current class
    tagMain.className = '';

    switch (formatCounter) {
        case 1:
            // unit font color
            if (darkFlag == 'on' && bckgrndFlag == "on") {
                tagMain.classList.add('txtUnitClr-Inv');
            } else {
                tagMain.classList.add('txtUnitClr');
            }
            break;
        case 2:
            // brown/yellow text
            if (darkFlag == 'on' && bckgrndFlag == "on") {
                tagMain.classList.add('txtBrnYlw-Inv');
            } else {
                tagMain.classList.add('txtBrnYlw');
            }
            break;
        case 3:
            // unit color highlight
            if (darkFlag == 'on' && bckgrndFlag == "on") {
                tagMain.classList.add('txtUnitHlt-Inv');
            } else {
                tagMain.classList.add('txtUnitHlt');
            }
            break;
        case 4:
            // yellow/brown highlight
            if (darkFlag == 'on' && bckgrndFlag == "on") {
                tagMain.classList.add('txtBrnYlwHlt-Inv');
            } else {
                tagMain.classList.add('txtBrnYlwHlt');
            }
            break;
        case 5:
            // bold;
            tagMain.classList.add('txtBold');
            break;
        case 6:
            // semibold
            tagMain.classList.add('txtSemiBold');
            break;
        case 7:
            // italics
            break;
        case 8:
            // underline
            tagMain.classList.add('txtUndln');
            break;
    }
}

// called from html, within id="pgNvModal"
function stopProp(event) {
    event.stopPropagation();
}

function setUpBkmkBox() {
    // set up bkmk dialog before opening it the first time on a new page

    // re if extra bookmarks are displayed yet in bkmks pane
    bkmkExtra = sessionStorage.getItem('bkmkExtra');
    if (bkmkExtra == 'Y') {
        idBkmkPane.classList.add("bkmkExtraOpen");
    }

    let bkmkUnit = localStorage.getItem('bkmkUnit-'.concat(edition, '1'));
    let label = "";
    if (bkmkUnit != null) {
        idBkmk1.className=(bkmkUnit.concat('Bkmk') + ' bkmkOn');
        // apply label if there's one
        label = localStorage.getItem('bkmkName-'.concat(edition, '1'));
        if (label != null) {
            idGoTo1.innerText = label;
        }
    }
    bkmkUnit = localStorage.getItem('bkmkUnit-'.concat(edition, '2'));
    if (bkmkUnit != null) {
        idBkmk2.className = (bkmkUnit.concat('Bkmk') + ' bkmkOn');
        label = localStorage.getItem('bkmkName-'.concat(edition, '2'));
        if (label != null) {
            idGoTo2.innerText = label;
        }
    }
    bkmkUnit = localStorage.getItem('bkmkUnit-'.concat(edition, '3'));
    if (bkmkUnit != null) {
        idBkmk3.className = (bkmkUnit.concat('Bkmk') + ' bkmkOn');
        label = localStorage.getItem('bkmkName-'.concat(edition, '3'));
        if (label != null) {
            idGoTo3.innerText = label;
        }
    }
    bkmkUnit = localStorage.getItem('bkmkUnit-'.concat(edition, '4'));
    if (bkmkUnit != null) {
        idBkmk4.className = (bkmkUnit.concat('Bkmk') + ' bkmkOn');
        label = localStorage.getItem('bkmkName-'.concat(edition, '4'));
        if (label != null) {
            idGoTo4.innerText = label;
        }
    }
    bkmkUnit = localStorage.getItem('bkmkUnit-'.concat(edition, '5'));
    if (bkmkUnit != null) {
        idBkmk5.className = (bkmkUnit.concat('Bkmk') + ' bkmkOn');
        label = localStorage.getItem('bkmkName-'.concat(edition, '5'));
        if (label != null) {
            idGoTo5.innerText = label;
        }
    }
    bkmkUnit = localStorage.getItem('bkmkUnit-'.concat(edition, '6'));
    if (bkmkUnit != null) {
        idBkmk6.className = (bkmkUnit.concat('Bkmk') + ' bkmkOn');
        label = localStorage.getItem('bkmkName-'.concat(edition, '6'));
        if (label != null) {
            idGoTo6.innerText = label;
        }
    }
    bkmkUnit = localStorage.getItem('bkmkUnit-'.concat(edition, '7'));
    if (bkmkUnit != null) {
        idBkmk7.className = (bkmkUnit.concat('Bkmk') + ' bkmkOn');
        label = localStorage.getItem('bkmkName-'.concat(edition, '7'));
        if (label != null) {
            idGoTo7.innerText = label;
        }
    }
    bkmkUnit = localStorage.getItem('bkmkUnit-'.concat(edition, '8'));
    if (bkmkUnit != null) {
        idBkmk8.className = (bkmkUnit.concat('Bkmk') + ' bkmkOn');
        label = localStorage.getItem('bkmkName-'.concat(edition, '8'));
        if (label != null) {
            idGoTo8.innerText = label;
        }
    }

}

function openBkmkBox(caller) {
    if (caller == 'app') {
        smlMenuChecks();
    }
    if (openMenuName != '') {
        closeLrgOverlay();
    }
    if (bkmksSetUp != 'y') {
        setUpBkmkBox();
        bkmksSetUp = 'y';
    }
    if (bkmksOpen=='y') {
        closeBkmkBox();
    } else {
        tagBody.classList.add('bkmkOpen');
        if (idKeyCont.classList.contains('optOpen')) {
            closeOpt();
        }
        bkmksOpen = 'y';
    }
}
function closeBkmkBox() {
    tagBody.classList.remove('bkmkOpen');
    bkmksOpen = 'n';
    closeBkmkNameBox();
}
function goToBkmk(bkNum) {
    let bkmkPage = localStorage.getItem('bkmkPage-'.concat(edition, bkNum));
    if (bkmkPage != null) {
        tagBody.classList.remove('bkmkOpen');
        let urlParts = location.href.split('#');
        if (urlParts[0] == bkmkPage) {
            // go directly to bkmk, on current page
            bkmkFromTop(bkNum);
        } else {
            // Set bkmkActivated flag to 'Y' so function bkmkFromTop() will be called when page is loaded (following next step).
            sessionStorage.setItem('bkmkActivated', 'Y');
            sessionStorage.setItem('bkmkNumActivated', bkNum);
            // go to page bkmk is on. bkmk will be scrolled down to when page is loaded
            window.location.href = bkmkPage;
        }
    }
}

function bkmkFromTop(bkNum) {
    scrollToBkmk = 'y';
    let scrollFromTop;
    let bkmkSettings = localStorage.getItem('bkmkSettings-'.concat(edition, bkNum));
    if (!bkmkSettings) { bkmkSettings = ""; }

    if (!isIOS) {
        CommentsOn('start', 'setBookmark');
    } else if (bkmkSettings != null) {
        // for iOS, if comments or sanserif were on when bkmk set, then turn on if not on already
        if (bkmkSettings.search('Comm') >= 0 && CommentsFlag != 'on') {
            CommentsFlag = 'on';
            toggleComments('bkmkFromTop');
        } else if (bkmkSettings.search('Comm') == -1 && CommentsFlag == 'on') {
            CommentsFlag = 'off';
            toggleComments('bkmkFromTop');
        }
        if (bkmkSettings.search('SanSrf') >= 0 && VerseFontFlag != 'on') {
            VerseFontFlag = 'on';
            fontToggle('bkmkFromTop');
        } else if (bkmkSettings.search('SanSrf') == -1 && VerseFontFlag == 'on') {
            VerseFontFlag = 'off';
            fontToggle('bkmkFromTop');
        }
    }
    scrollFromTop = idMainPartInt.offsetTop + (localStorage.getItem('bkmkTop-'.concat(edition, bkNum)) * idMainPartInt.clientHeight);
    tagHTML.scrollTop = scrollFromTop;

    if (!isIOS) { CommentsOn('end', 'setBookmark'); }
}

function setBkmk(bkNum) {
    if (document.getElementById('bkmk' + bkNum).classList != "") { return; }
    let urlParts = location.href.split('#');
    let docScrollTop;
    let bkmkSettings = "";
    scrollToBkmk = 'y';
    document.getElementById('bkmkInput').value = null; //ensure bkmkName box is empty

    localStorage.setItem('bkmkPage-'.concat(edition, bkNum), urlParts[0]);
    // Need to get percentage from top with comments on & right pane off.
    // Also allow for distance idMainPartInt is from top & height of bar at top of smaller screens.
    if (isIOS) {
        // iOS needs to have Comments & Font the same when come back to bookmark position as they were when it was set.
        if (CommentsFlag == 'on') {
            bkmkSettings = 'Comm';
        }
        if (VerseFontFlag == 'on') {
            bkmkSettings = bkmkSettings.concat('SanSrf');
        }
        if (tagBody.scrollTop == 0 || tagBody.scrollTop == null) {
            docScrollTop = tagHTML.scrollTop;
        } else {
            // older iOS
            docScrollTop = tagBody.scrollTop;
            bkmkSettings = bkmkSettings.concat('bodyScroll');
        }
        localStorage.setItem('bkmkSettings-'.concat(edition, bkNum), bkmkSettings);
        localStorage.setItem('bkmkTop-'.concat(edition, bkNum), (docScrollTop - idMainPartInt.offsetTop) / idMainPartInt.clientHeight);
    } else {
        CommentsOn('start', 'setBookmark');
        // NB: clientHeight includes padding but not border or margin. (But seems to give incorrect value in landscape orientation!)
        localStorage.setItem('bkmkTop-'.concat(edition, bkNum), (tagHTML.scrollTop - idMainPartInt.offsetTop) / idMainPartInt.clientHeight);
        CommentsOn('end', 'setBookmark');
    }
    
    let letter = unit.charAt(unit.length - 1);
    bkmkUnit = letter.concat('Bkmk');
    switch (bkNum) {
        case '1':
            idBkmk1.className = bkmkUnit + " bkmkOn";
            break;
        case '2':
            idBkmk2.className = bkmkUnit + " bkmkOn";
            break;
        case '3':
            idBkmk3.className = bkmkUnit + " bkmkOn";
            break;
        case '4':
            idBkmk4.className = bkmkUnit + " bkmkOn";
            break;
        case '5':
            idBkmk5.className = bkmkUnit + " bkmkOn";
            break;
        case '6':
            idBkmk6.className = bkmkUnit + " bkmkOn";
            break;
        case '7':
            idBkmk7.className = bkmkUnit + " bkmkOn";
            break;
        case '8':
            idBkmk8.className = bkmkUnit + " bkmkOn";
            break;
    }
    localStorage.setItem('bkmkUnit-'.concat(edition, bkNum), letter);
    bkmkLabelNum = bkNum;
    idBkmkName.className = "bkNameOpen";
    document.getElementById('bkmkInput').focus();
    setTimeout(function () { idBkmkPane.scrollTo({ top: tagBody.scrollHeight, behavior: 'smooth' }); }, 500);

}

function bkmkName() {
    const input = document.getElementById('bkmkInput');
    let label = input.value;
    if (label != "") {
        switch (bkmkLabelNum) {
            case '1':
                idGoTo1.innerText = label;
                break;
            case '2':
                idGoTo2.innerText = label;
                break;
            case '3':
                idGoTo3.innerText = label;
                break;
            case '4':
                idGoTo4.innerText = label;
                break;
            case '5':
                idGoTo5.innerText = label;
                break;
            case '6':
                idGoTo6.innerText = label;
                break;
            case '7':
                idGoTo7.innerText = label;
                break;
            case '8':
                idGoTo8.innerText = label;
                break;
        }
        localStorage.setItem('bkmkName-'.concat(edition, bkmkLabelNum), label);
    }
    closeBkmkNameBox();
}
function closeBkmkNameBox() {
    document.getElementById('bkmkInput').value = null;
    idBkmkName.className = "";
}

function clearBkmk(bkNum) {
    //for some reason .className = "" doesn't work
    let bkmkUnit = localStorage.getItem('bkmkUnit-'.concat(edition, bkNum));
    if (bkmkUnit != null) {
        switch (bkNum) {
            case '1':
                idBkmk1.className = "";
                idGoTo1.innerText = "Go to";
                break;
            case '2':
                idBkmk2.className = "";
                idGoTo2.innerText = "Go to";
                break;
            case '3':
                idBkmk3.className = "";
                idGoTo3.innerText = "Go to";
                break;
            case '4':
                idBkmk4.className = "";
                idGoTo4.innerText = "Go to";
                break;
            case '5':
                idBkmk5.className = "";
                idGoTo5.innerText = "Go to";
                break;
            case '6':
                idBkmk6.className = "";
                idGoTo6.innerText = "Go to";
                break;
            case '7':
                idBkmk7.className = "";
                idGoTo7.innerText = "Go to";
                break;
            case '8':
                idBkmk8.className = "";
                idGoTo8.innerText = "Go to";
                break;
        }
        idBkmkName.className = "";

        localStorage.removeItem('bkmkUnit-'.concat(edition, bkNum));
        localStorage.removeItem('bkmkPage-'.concat(edition, bkNum));
        localStorage.removeItem('bkmkTop-'.concat(edition, bkNum));
        localStorage.removeItem('bkmkName-'.concat(edition, bkNum));
    }
}

function CommentsOn(state) {
    if (state == 'start') {
        // Need to get scrollTop value with comments on, font as SanSerif option & right pane off.
        if (CommentsFlag != 'on') {
            document.querySelectorAll('.tran').forEach(function (e) { e.style.setProperty('transition', 'none', 'important'); });
            tagBody.classList.add("com-on");
        }
        if (VerseFontFlag != 'on') {
            tagBody.classList.add("SanSerif");
        }
        if (x.matches && HeadingsFlag == 'on') {
            idRightNav.style.display = 'none';
        }

    } else if (state == 'end') {
        if (CommentsFlag != 'on') {
            tagBody.classList.remove("com-on");
            setTimeout(comOnLoopNull, 10);
        }
        if (VerseFontFlag != 'on') {
            tagBody.classList.remove("SanSerif");
        }
        if (x.matches && HeadingsFlag == 'on') {
            idRightNav.style.display = null;
        }
    }
}
function dskMenuToggle(caller) {
    if ((dskMenuFlag != 'on' && caller == 'btn') || (dskMenuFlag == 'on' && caller == 'body0')) {
        tagBody.classList.add('menuOn');
        if (caller=='btn' && HeadingsFlag == "on") {
            reset_rnWidth('menuShow');
        }
        dskMenuFlag = 'on';
        localStorage.setItem('menuFlag', 'on');
    } else if (dskMenuFlag == 'on' && caller != 'body0') {
        // in case a menu is open
        if (openMenuName != '') {
            idMenuOverlays.style.transition = "0s";
            closeLrgOverlay();
        }
        tagBody.classList.remove('menuOn');
        if (caller == 'btn' && HeadingsFlag == "on") {
            reset_rnWidth('menuHide');
        }
        dskMenuFlag = 'off';
        localStorage.removeItem('menuFlag');
    }
}
function reset_rnWidth(status) {
    var tweak;
    if (status == 'menuShow') {
        tweak = -103;
    } else {
        tweak = 103;
    }
    rnWidth = parseInt(rnWidth) + tweak;
    r.style.setProperty('--rnwidth', rnWidth + 'px');
    r.style.setProperty('--rnCtrlsWidth', rnWidth - 3 + 'px');
    if (paneLtFlag == 'on') {
        idGoLeft.style.left = (parseFloat(idGoLeft.style.left) + tweak) + "px";
    } else {
        idGoRight.style.right = (parseFloat(idGoRight.style.right) + tweak) + "px";
        idGoTop.style.right = (parseFloat(idGoTop.style.right) + tweak) + "px";
    }
    sldr.max = parseInt(sldr.max) + tweak;
    sldr.value = rnWidth;
    localStorage.setItem('rtnavWidth', rnWidth);
    localStorage.setItem("SliderMax", sldr.max);
}

function paneMove(caller) {
    idOptions.classList.add('tempBorders');
    if ((paneLtFlag != 'on' && caller == 'btnPnLeft') || (paneLtFlag == 'on' && caller == 'body0')) {
        tagBody.classList.add('paneLt');
        paneLtFlag = 'on';
        localStorage.setItem('paneLtFlag', 'on');
    } else if (paneLtFlag == 'on' && caller == 'btnPnRight') {
        tagBody.classList.remove('paneLt');
        paneLtFlag = 'off';
        localStorage.removeItem('paneLtFlag');
    }
    setTimeout(function () { idOptions.classList.remove('tempBorders'); }, 1001);
}

function fontToggle(caller, cbFlag) {
    // On mobiles, prevent nav buttons showing if not already
    if (caller == 'btn' && x549.matches) { displayNavBtns = false; }

    if (VerseFontFlag == 'on' && (caller == 'body0' || caller == 'bkmkFromTop')) {
        tagBody.classList.add("SanSerif");
        idCbFont.checked = true;
    } else if ((VerseFontFlag != 'on' && caller == 'bkmkFromTop') || (VerseFontFlag == 'on' && caller == 'btn')) {
        tagBody.classList.remove("SanSerif");
        if (cbFlag != 'chbox') {
            idCbFont.checked = false;
        }
        VerseFontFlag = 'off';
        localStorage.setItem('VerseFontFlag', 'off');
    } else if (VerseFontFlag != 'on' && caller == 'btn') {
        VerseFontFlag = 'on';
        localStorage.setItem('VerseFontFlag', 'on');
        tagBody.classList.add("SanSerif");
        if (cbFlag != 'chbox') {
            idCbFont.checked = true;
        }
    }
    setTimeout(function () { displayNavBtns = null; }, 100);
}

function filterHeads() {
    let filter, a, i, txtValue, srchInput;
    const input = document.getElementById("searchInput");
    srchInput = input.value;
    filter = input.value.toUpperCase();
    const dv = document.getElementById("searchUL");
    const a1 = dv.getElementsByTagName("a");
    for (i = 0; i < a1.length; i++) {
        a = a1[i];
        txtValue = a.textContent;
        if (txtValue.toUpperCase().indexOf(filter) > -1) {
            a1[i].style.display = "";
        } else {
            a1[i].style.display = "none";
        }
    }
    sessionStorage.setItem("srchTerm", srchInput);
}

function clearSearch() {
    let idSrchInput= document.getElementById('searchInput');
    idSrchInput.value = '';
    filterHeads();
    idSrchInput.focus();
}

function searchPageLoad(editionSearch) {
    let idSrchInput= document.getElementById('searchInput');
    let prevSrchInput = sessionStorage.getItem("srchTerm");
    if (prevSrchInput != "") {
        idSrchInput.value = prevSrchInput;
        filterHeads();
    }
    // other intro stuff
    invert('body0', 'NA', editionSearch);
    toggleHeadings('body0');

    idSrchInput.focus();
}

// This is called when click on a link in the Scripture or Subject menus that's on same page.
function iLnk(anchorName) {
    // ensure menus closed
    if (openMenuName != '') {  // large menu open
        idMenuOverlays.style.transition = "0s";
        closeLrgOverlay();
    } else {   // small menu open
        idSmlMenu.style.transition = "0s";
        if (toggleBtnsFlag == 'on') {
            tagHTML.className = "btnsVis";
        } else {
            tagHTML.className = "";
        }
        idSmlMenu.style.top = null;
        idSmlBuff.style.display = null;
        setTimeout(function () { idSmlMenu.style.transition = null; }, 600);
    }
    document.getElementById(anchorName).scrollIntoView(true);
}

function changeTestamentMenu(testament) {
    if (testament == 'nt') {
        document.getElementById("indx-lnks-parent").classList.add("nt-menu");
        document.getElementById("indx-lnks-parent").classList.remove("ot-menu");
   } else {
        document.getElementById("indx-lnks-parent").classList.add("ot-menu");
        document.getElementById("indx-lnks-parent").classList.remove("nt-menu");
    }
}


function openOpt(caller) {
    if (caller == 'app') {
        smlMenuChecks();
    }
    if (idOptions.clientHeight > '0') {
        closeOpt();
    } else {
        if (openMenuName != '') {
            closeLrgOverlay();
        }
        idKeyCont.classList.add('optOpen');
        idOptOpenDsk.classList.add('optDisplay');
        // select elements need to be reset in case Back button was used.
        if (frmElementsReset != 'y') {
            if (fSize != null) { idFontSize.value = fSize; }
            if (lnHgt != null) { idLineHt.value = lnHgt; } 
            idBckgrnd.value = bkgdClr;
            if (HeadingsFlag != 'on') { idCbHead.checked = false; } else { idCbHead.checked = true; }
            if (CommentsFlag != 'on') { idCbComm.checked = false; } else { idCbComm.checked = true; }
            if (VerseFontFlag != 'on') { idCbFont.checked = false; } else { idCbFont.checked = true; }
            if (toggleBtnsFlag != 'on') { idCbTogBtns.checked = false; } else { idCbTogBtns.checked = true; }
            if (bckgrndFlag != 'on') { idcbBckgrnd.checked = false; } else { idcbBckgrnd.checked = true; }
            if (formatOnOff != 'on') { idCbHlt.checked = false; } else { idCbHlt.checked = true; }
            frmElementsReset = 'y';
        }
        if (bkmksOpen == 'y') {
            closeBkmkBox();
        }
        setTimeout(function () { idOptions.style.overflowY = 'auto'; }, 1002);
    }
}
function closeOpt() {
    idOptions.style.overflowY = 'hidden';
    idKeyCont.classList.remove('optOpen');
    idOptOpenDsk.classList.remove('optDisplay');
    if (optExpBox != null) {
        document.getElementById("exp".concat(optExpBox)).style.display = null;
        optExpBox = null;
    }
}
// called from openOpt & openBkmkBox
function smlMenuChecks() {
    if (smallMenuOpen == 'y') {
        if (smallOverlayOpen == 'y') {
            closeSmlOverlay();
            smallOverlayOpen = 'n';
        }
        closeSmlMenu();
        smallMenuOpen = 'n';
    }
}
function fontSize(caller) {
    if (caller == 'body0') {
        if (fSize != null) {
            idFontSize.value = fSize;
            r.style.fontSize = fSize + 'px';
        }
    } else { // caller will be font select element;
        let selSize = idFontSize.options[idFontSize.selectedIndex];
        tagBody.classList.add("noTrans");
        r.style.fontSize = selSize.value + 'px';
        setTimeout(function () { tagBody.classList.remove("noTrans"); }, 10);
        localStorage.setItem('fSize', selSize.value);
    }
}
function lineHt(caller) {
    if (caller == 'body0') {
       if (lnHgt != null) {
            idLineHt.value = lnHgt;
            idMainPart.classList.add('lnHt' + lnHgt);
        }
    } else { // caller will be line height select element;
        let selSize = idLineHt.options[idLineHt.selectedIndex];
        idMainPart.className = '';  // Remove all classes from Main tag
        if (selSize.value == 'Medium') {
            localStorage.removeItem('lnHgt');
        } else {
            idMainPart.classList.add('lnHt' + selSize.value);
            localStorage.setItem('lnHgt', selSize.value);
       }
    }
}
function toggleBtns(caller) {
    let topMob = document.getElementsByClassName("topmob")[0];

    if (toggleBtnsFlag == 'on' && caller == 'body0') {
        topMob.style.display = "flex";
        setTimeout(function () { tagHTML.classList.add('btnsVis'); }, 10);
        tagHTML.classList.add('btnsVis');
        idCbTogBtns.checked = true;
    } else if (toggleBtnsFlag == 'on' && caller == 'btn') {
        tagHTML.classList.remove('btnsVis');
        setTimeout(function () { topMob.style.display = null; }, 510);
        toggleBtnsFlag = 'off';
        localStorage.setItem('toggleBtnsFlag', 'off');
    } else if (toggleBtnsFlag != 'on' && caller == 'btn') {
        topMob.style.display = "flex";
        setTimeout(function () {tagHTML.classList.add('btnsVis');}, 10);
        toggleBtnsFlag = 'on';
        localStorage.setItem('toggleBtnsFlag', 'on');
    }
}

function bkmkShowExtra() {
    if (bkmkExtra != 'Y') {
        idBkmkPane.classList.add("bkmkExtraOpen");
        idBkmkExtra.scrollIntoView({behavior: "smooth"});
        bkmkExtra = 'Y';
        sessionStorage.setItem('bkmkExtra', 'Y');
	} else {
        idBkmkPane.classList.remove("bkmkExtraOpen");
        bkmkExtra = 'N';
        sessionStorage.setItem('bkmkExtra', 'N');
    }
}


function optsColor() {
    if (colOptOpen != 'Y') {
        idOptions.classList.add("optsColorOpen");
        pal.scrollIntoView({ behavior: "smooth" });
        colOptOpen = 'Y';
        sessionStorage.setItem('colOptOpen', 'Y');
    } else {
        document.querySelector("#optFlex").scrollIntoView({ behavior: "smooth" });
        colOptOpen = 'N';
        sessionStorage.setItem('colOptOpen', 'N');
        setTimeout(function () { idOptions.classList.remove("optsColorOpen"); }, 320);
    }
}

function tipsDisplay() {
    var tips = document.getElementById('tips');
    if (tipsOpen != 'Y') {
        tagBody.classList.add("tipsOpen");
        tips.scrollIntoView({ behavior: "smooth" });
        tipsOpen = 'Y';
        sessionStorage.setItem('tipsOpen', 'Y');
    } else {
        window.scrollTo({ top: 0, behavior: 'smooth' });
        tipsOpen = 'N';
        sessionStorage.setItem('tipsOpen', 'N');
        setTimeout(function () { tagBody.classList.remove("tipsOpen"); }, 300);
    }
}


// Settings pop-ups
function expAll(caller, close) {
    const boxID = document.getElementById("exp".concat(caller));
    if (close == 'cls') {
        boxID.style.display = null;
        optExpBox = null;
    } else if (optExpBox == null) {
        boxID.style.display = "block";
        optExpBox = caller;
    } else if (optExpBox == caller) {
        boxID.style.display = null;
        optExpBox = null;
    } else {
        document.getElementById("exp".concat(optExpBox)).style.display = null;
        boxID.style.display = "block";
        optExpBox = caller;
    }
}

// Close pgNv modal
function clsPgNvMod(caller) {
    idPgNvModal.style.display = null;
    if (caller == 'optOut') {
        // Ensure doesn't display again
        localStorage.setItem('pgNvMdlNever', 'y');
    }
}

function bckgrndChange(caller, sldrCaller, sldrVal) {
    if (caller != 'slider') {
        bckgrndInitial();
    } else if (sldrCaller == 'sldTop') {
        sldrBkgd.value = sldrVal;
        sldrBkgdApp.value = sldrVal;
    } else if (sldrCaller == 'sldOpt') {
        sldrBkgdTop.value = sldrVal;
        sldrBkgdApp.value = sldrVal;
    } else {
        sldrBkgdTop.value = sldrVal;
        sldrBkgd.value = sldrVal;
    }

   // Assign background-color
    switch (bkgdClr) {
        case 'ltYlw':
            for (let i = 0; i < sldrBkgdClass.length; i++) {
                sldrBkgdClass[i].min = 98;
                sldrBkgdClass[i].max = 108;
                sldrBkgdClass[i].step = 1;
            }
            hue = 45;
            stn = 100;
            if (caller == 'btnOn' && ltYlwLgt != null) {
                lgt = ltYlwLgt;
            } else {
                if (caller == 'slider') {
                    ltYlwSldr = sldrVal;
                    localStorage.setItem('ltYlwSldr', ltYlwSldr);
                } else {
                    if (ltYlwSldr == null) {
                        ltYlwSldr = localStorage.getItem('ltYlwSldr');
                        if (ltYlwSldr == null) {
                            ltYlwSldr = 103;
                            localStorage.setItem('ltYlwSldr', ltYlwSldr);
                        }
                    }
                    setTimeout(function () { sldrBkgdTop.value = ltYlwSldr; sldrBkgd.value = ltYlwSldr; sldrBkgdApp.value = ltYlwSldr; }, 20);
                }

                lgt = 90 * ltYlwSldr / 100;
                ltYlwLgt = lgt;
            }
            break;

        case 'ltBlue':
            for (let i = 0; i < sldrBkgdClass.length; i++) {
                sldrBkgdClass[i].min = 97;
                sldrBkgdClass[i].max = 107;
                sldrBkgdClass[i].step = 1;
            }
            hue = 208;
            stn = 100;
            if (caller == 'btnOn' && ltBlueLgt != null) {
                lgt = ltBlueLgt;
            } else {
                if (caller == 'slider') {
                    ltBlueSldr = sldrVal;
                    localStorage.setItem('ltBlueSldr', ltBlueSldr);
                } else {
                    if (ltBlueSldr == null) {
                        ltBlueSldr = localStorage.getItem('ltBlueSldr');
                        if (ltBlueSldr == null) {
                            ltBlueSldr = 102;
                            localStorage.setItem('ltBlueSldr', ltBlueSldr);
                        }
                    }
                    setTimeout(function () { sldrBkgdTop.value = ltBlueSldr; sldrBkgd.value = ltBlueSldr; sldrBkgdApp.value = ltBlueSldr; }, 20);
                }

                lgt = 92 * ltBlueSldr / 100;
                ltBlueLgt = lgt;
            }
            break;

        case 'dkBlack':
            for (let i = 0; i < sldrBkgdClass.length; i++) {
                sldrBkgdClass[i].min = 0;
                sldrBkgdClass[i].max = 5;
                sldrBkgdClass[i].step = 0.5;
            }
            hue = 0;
            stn = 0;

            if (caller == 'btnOn' && dkBlackLgt != null) {
                lgt = dkBlackLgt;
            } else {
                if (caller == 'slider') {
                    dkBlackSldr = sldrVal;
                    localStorage.setItem('dkBlackSldr', dkBlackSldr);
                } else {
                    if (dkBlackSldr == null) {
                        dkBlackSldr = localStorage.getItem('dkBlackSldr');
                        if (dkBlackSldr == null) {  // only true not ever been set to localstorage (& not cleared since)
                            dkBlackSldr = 1;
                            localStorage.setItem('dkBlackSldr', dkBlackSldr);
                        }
                    }
                    setTimeout(function () { sldrBkgdTop.value = dkBlackSldr; sldrBkgd.value = dkBlackSldr; sldrBkgdApp.value = dkBlackSldr; }, 20);
                }
                lgt = 7 * dkBlackSldr;
                dkBlackLgt = lgt;
            }
            break;

        case 'dkBlue':
            for (let i = 0; i < sldrBkgdClass.length; i++) {
                sldrBkgdClass[i].min = 0.5;
                sldrBkgdClass[i].max = 1.5;
                sldrBkgdClass[i].step = 0.1;
            }
            hue = 240;
            stn = 63.5;

            if (caller == 'btnOn' && dkBlueLgt != null) {
                lgt = dkBlueLgt;
            } else {
                if (caller == 'slider') {
                    dkBlueSldr = sldrVal;
                    localStorage.setItem('dkBlueSldr', dkBlueSldr);
                } else {
                    if (dkBlueSldr == null) {
                        dkBlueSldr = localStorage.getItem('dkBlueSldr');
                        if (dkBlueSldr == null) {  // only true not ever been set to localstorage (& not cleared since)
                            dkBlueSldr = 0.9;
                            localStorage.setItem('dkBlueSldr', dkBlueSldr);
                        }
                    }
                    setTimeout(function () { sldrBkgdTop.value = dkBlueSldr; sldrBkgd.value = dkBlueSldr; sldrBkgdApp.value = dkBlueSldr; }, 20);
                }
                lgt = 26.86 * dkBlueSldr;
                dkBlueLgt = lgt;
            }
            break;

        case 'dkUnit':
            for (let i = 0; i < sldrBkgdClass.length; i++) {
                sldrBkgdClass[i].min = 0.5;
                sldrBkgdClass[i].max = 1.5;
                sldrBkgdClass[i].step = 0.1;
            }
            stn = 100;
            dkUnitSldrName = 'SldrDk_' + unit.charAt(unit.length - 1);

            // This 'if' will be true if have already selected dkUnit while still on current page
            // Also lgtStart & dkUnitSldr will have values. But can't calculate lgt yet in case caller is slider
            if (dkUnitPrev == unit) {
                hue = dkUnitHuePrev;
                if (unit == 'NA') { stn = 0; }
            } else {
                switch (unit) {
                    case 'unit_a':
                        hue = 334;
                        lgtStart = 18;
                        break;
                    case 'unit_b':
                        hue = 0;
                        lgtStart = 18.63;
                        break;
                    case 'unit_c':
                        hue = 29.3;
                        lgtStart = 18.86;
                        break;
                    case 'unit_d':
                        hue = 43.42;
                        lgtStart = 14.9;
                        break;
                    case 'unit_e':
                        hue = 120;
                        lgtStart = 14.9;
                        break;
                    case 'unit_f':
                        hue = 180;
                        lgtStart = 13.7;
                        break;
                    case 'unit_g':
                        hue = 240;
                        lgtStart = 19.6;
                        break;
                    case 'unit_h':
                        hue = 283;
                        lgtStart = 19.6;
                        break;
                    case 'NA':
                      //  dkUnitSldrName = 'SldrDk_NA';
                        stn = 0;
                        hue = 0;
                        lgtStart = 21;
                }
            }

            if (caller == 'btnOn' && dkUnitLgt != null) {
                lgt = dkUnitLgt;
            } else {
                if (caller == 'slider') {
                    dkUnitSldr = sldrVal;
                    localStorage.setItem(dkUnitSldrName, dkUnitSldr);
                } else {
                    if (dkUnitSldr == null) {
                        dkUnitSldr = localStorage.getItem(dkUnitSldrName);
                        if (dkUnitSldr == null) {
                            dkUnitSldr = 1;
                            localStorage.setItem(dkUnitSldrName, dkUnitSldr);
                        }
                    }
                    setTimeout(function () { sldrBkgdTop.value = dkUnitSldr; sldrBkgd.value = dkUnitSldr; sldrBkgdApp.value = dkUnitSldr; }, 20);
                }

                lgt = lgtStart * dkUnitSldr;
                dkUnitLgt = lgt;

                // localStorage.setItem('SldrDk_Prev', dkUnitSldr);
                // save settings for if dkUnit is again chosen while still on current page
                dkUnitHuePrev = hue;
                dkUnitPrev = unit;
            }
          break;

        case 'ltUnit':
            if (unit == 'NA') {
                stn = 0;
            } else {
                stn = 100;
            }
            for (let i = 0; i < sldrBkgdClass.length; i++) {
                sldrBkgdClass[i].min = 89;
                sldrBkgdClass[i].max = 99;
                sldrBkgdClass[i].step = 1;
            }
            ltUnitSldrName = 'SldrLt_' + unit.charAt(unit.length - 1);

            // This 'if' will be true if have already selected ltUnit while still on current page
            // Also ltUnitSldr will have value. But can't calculate lgt yet in case caller is slider
            if (ltUnitPrev == unit) {
                hue = ltUnitHuePrev;
            } else {
                // Unlike dkUnit, don't need to set a lgtStart variable, as always will be 96
                switch (unit) {
                    case 'unit_a':
                        hue = 333;
                        break;
                    case 'unit_b':
                        hue = 0;
                        break;
                    case 'unit_c':
                        hue = 27;
                        break;
                    case 'unit_d':
                        hue = 51;
                        break;
                    case 'unit_e':
                        hue = 120;
                        break;
                    case 'unit_f':
                        hue = 194;
                        break;
                    case 'unit_g':
                        hue = 240;
                        break;
                    case 'unit_h':
                        hue = 281;
                        break;
                    case 'NA':
                        hue = 0;
                }
            }

            if (caller == 'btnOn' && ltUnitLgt != null) {
                lgt = ltUnitLgt;
            } else {
                if (caller == 'slider') {
                    ltUnitSldr = sldrVal;
                    localStorage.setItem(ltUnitSldrName, ltUnitSldr);
                } else {
                    if (ltUnitSldr == null) {
                        ltUnitSldr = localStorage.getItem(ltUnitSldrName);
                        if (ltUnitSldr == null) {
                            ltUnitSldr = localStorage.getItem('SldrLt_Prev');
                            if (ltUnitSldr == null) {
                                ltUnitSldr = 94;
                            }
                            localStorage.setItem(ltUnitSldrName, ltUnitSldr);
                        }
                    }
                    setTimeout(function () { sldrBkgdTop.value = ltUnitSldr; sldrBkgd.value = ltUnitSldr; sldrBkgdApp.value = ltUnitSldr }, 20);
                }

                lgt = ltUnitSldr;
                ltUnitLgt = lgt;

                localStorage.setItem('SldrLt_Prev', ltUnitSldr);
                // save settings for if ltUnit is again chosen while still on current page
                ltUnitHuePrev = hue;
                ltUnitPrev = unit;
            }
          break;
    }

    if (bckgrndFlag == 'on') {
        tagBody.classList.remove(bkgdPrv);
        tagBody.classList.add(bkgdClr);
        bkgrClr = 'hsl(' + hue + 'deg, ' + stn + '%, ' + lgt + '%)';
        r.style.setProperty('--backgrnd-clr', bkgrClr);
    }
    localStorage.setItem('bkgdClr', bkgdClr);
}

idBckgrnd.onchange = function () {
    bckgrndChange('dropDown', null);
};
sldrBkgdTop.oninput = function () {
    bckgrndChange('slider', 'sldTop', this.value);
};
sldrBkgd.oninput = function () {
    bckgrndChange('slider', 'sldOpt', this.value);
};
sldrBkgdApp.oninput = function () {
    bckgrndChange('slider', 'sldApp', this.value);
};
sldrBkgdTop.onmousedown = function () {
    bckgrndInitial();
};
sldrBkgd.onmousedown = function () {
    bckgrndInitial();
};
sldrBkgdApp.onmousedown = function () {
    bckgrndInitial();
};
function bckgrndInitial () {
    bkgdPrv = bkgdClr;
    let selBckgrnd = idBckgrnd.options[idBckgrnd.selectedIndex];
    bkgdClr = selBckgrnd.value;
    // First get night sorted
    switch (bkgdClr) {
        case 'ltUnit':
        case 'ltBlue':
        case 'ltYlw':
        case 'ltRed':
        case 'ltGrn':
            if (darkFlag == 'on') {  // can only be on if bckgrndFlag == 'on'
                darkFlag = 'off';
                tagBody.classList.remove("night");
                tagBody.style.backgroundColor = null;
                defaultClrs();
                if (formatOnOff == 'on') { highlightApply(); }
                localStorage.setItem('darkFlag', 'off');
            }
            break;
        default:
            if (darkFlag != 'on') {
                darkFlag = 'on';
                if (formatOnOff == 'on') { highlightApply(); }
                localStorage.setItem('darkFlag', 'on');
            }
            if (bckgrndFlag == 'on') { tagBody.classList.add("night"); nightClrs(); }
    }
}

function defaultClrs() {
    r.style.setProperty('--clrA', 'rgb(197 48 123)');
    r.style.setProperty('--clrB', 'rgb(221 17 17)');
    r.style.setProperty('--clrC', 'rgb(210 91 0)');
    r.style.setProperty('--clrD', 'rgb(165 117 0)');
    r.style.setProperty('--clrE', 'rgb(0 154 0)');
    r.style.setProperty('--clrF', 'rgb(0 141 141)');
    r.style.setProperty('--clrG', 'rgb(27 27 214)');
    r.style.setProperty('--clrH', 'rgb(129 32 222)');

    r.style.setProperty('--clrCh5', 'rgb(196 85 0)');
    r.style.setProperty('--clrDh5', 'rgb(156 110 0)');
    r.style.setProperty('--clrEh5', 'rgb(0 138 0)');
    r.style.setProperty('--clrFh5', 'rgb(0 132 132)');
}
function nightClrs() {
    r.style.setProperty('--clrA', 'rgb(255 181 219)');
    r.style.setProperty('--clrB', 'rgb(255 190 190)');
    r.style.setProperty('--clrC', 'rgb(255 221 153)');
    r.style.setProperty('--clrD', 'rgb(255 240 153)');
    r.style.setProperty('--clrE', 'rgb(179 255 179)');
    r.style.setProperty('--clrF', 'rgb(100 255 255)');
    r.style.setProperty('--clrG', 'rgb(192 192 255)');
    r.style.setProperty('--clrH', 'rgb(236 187 255)');

    r.style.setProperty('--clrCh5', 'rgb(255 221 153)');
    r.style.setProperty('--clrDh5', 'rgb(255 240 153)');
    r.style.setProperty('--clrEh5', 'rgb(179 255 179)');
    r.style.setProperty('--clrFh5', 'rgb(100 255 255)');
}

document.onreadystatechange = function () {
    if (document.readyState === "complete") {
        idLoader.style.display = "none";
    } else {
        idLoader.style.visiblity = "visible";
    }
};

function trans0s() {
    tagBody.classList.add("trans0s");
}